// Go support for Protocol Buffers - Google's data interchange format
//
// Copyright 2010 The Go Authors.  All rights reserved.
// https://github.com/golang/protobuf
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
//     * Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above
// copyright notice, this list of conditions and the following disclaimer
// in the documentation and/or other materials provided with the
// distribution.
//     * Neither the name of Google Inc. nor the names of its
// contributors may be used to endorse or promote products derived from
// this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

// +build go1.9

package testdata

import (
	"testing"

	mainpb "github.com/golang/protobuf/protoc-gen-go/testdata/import_public"
	subpb "github.com/golang/protobuf/protoc-gen-go/testdata/import_public/sub"
)

func TestImportPublicLink(t *testing.T) {
	// mainpb.[ME] should be interchangable with subpb.[ME].
	var _ mainpb.M = subpb.M{}
	var _ mainpb.E = subpb.E(0)
	_ = &mainpb.Public{
		M: &mainpb.M{},
		E: mainpb.E_ZERO.Enum(),
		Local: &mainpb.Local{
			M: &mainpb.M{},
			E: mainpb.E_ZERO.Enum(),
		},
	}
	_ = &mainpb.Public{
		M: &subpb.M{},
		E: subpb.E_ZERO.Enum(),
		Local: &mainpb.Local{
			M: &subpb.M{},
			E: subpb.E_ZERO.Enum(),
		},
	}
	_ = &mainpb.M{
		M2: &subpb.M2{},
	}
}
